
// #name = PJ Tribes 2 Mega Faves
// #version = 7.04
// #date = March 21, 2003
// #author = Mark Dickenson ([AKA]PanamaJack)
// #email = akapanamajack@wildmail.com
// #web = http://www.planetstarsiege.com/pj
// #description = Gives you 20 favorites for each map.
// #acknowledgements = none
// #status = finished
// 
// $PJRuleSet = Mod Type

$PJVersion::MegaFaves = "7.04";

function noPJPackage(%name) {
	MessageBoxOK("Missing Support", "<just:center><Font:Univers Condensed:14><color:2cacb5>You need <color:ffffff>PJ's Support Package <color:2cacb5>to run PJ Scripts.\n" @ %name @ "\n<color:2cacb5>You must<color:ffffff> DOWNLOAD<color:2cacb5> it before playing.\n\n<color:ffffff>http://www.planettribes.com/pj", "" );
}

if(!isObject(PJGlobalOption))
    new ScriptObject(PJGlobalOption){};

if(!isObject(PJOptionList))
    new ScriptObject(PJOptionList){};

PJOptionList.scriptcount++;
PJOptionList.guipath[PJOptionList.scriptcount] = "scripts/autoexec/panamajack/gui/pjmegafaves.gui";
PJOptionList.enablevariable[PJOptionList.scriptcount] = "$PJEnable::MegaFaves";
PJOptionList.selectcommand[PJOptionList.scriptcount] = "canvas.PushDialog(PJMegaFavesOptionDlg);";
PJOptionList.listtext[PJOptionList.scriptcount] = "PJ's Mega Faves - " @ $PJVersion::MegaFaves;
PJOptionList.readmepath[PJOptionList.scriptcount] = "scripts/autoexec/panamajack/readme/megafaves.txt";
PJOptionList.activate[PJOptionList.scriptcount] = "addMegaFaves";
PJOptionList.deactivate[PJOptionList.scriptcount] = "removeMegaFaves";
PJOptionList.preloadgui[PJOptionList.scriptcount] = 0;
PJOptionList.picturepath[PJOptionList.scriptcount] = "panamajack/scripts/megafaves.jpg";
PJOptionList.author[PJOptionList.scriptcount] = "Panama Jack";

if(!isObject(PJPackageData))
    new ScriptObject(PJPackageData){};

function addpackage(%packagedfunction, %function, %beforeafter){

	PJPackageData.count[%packagedfunction @ %beforeafter]++;
	%temp = %packagedfunction @ %beforeafter @ PJPackageData.count[%packagedfunction @ %beforeafter];
	PJPackageData.funccall[%temp] = %function;
}

package PJPackageLoadmega {

function InventoryScreen::setupHud( %this, %tag ) {

	parent::setupHud( %this, %tag );

	if($PJEnable::MegaFaves == 1) {
		$Hud[%tag].staticData[1, 0].command = "savePJFavorite();";
		$Hud[%tag].staticData[1, 1].altCommand = "savePJFavorite();";
	}
}

};

activatepackage(PJPackageLoadmega);

addpackage("DispatchLaunchMode", "DispatchLaunchModeFaves", "before");
addpackage("DispatchLaunchMode", "DispatchLaunchModeFaves2", "after");

function DispatchLaunchModeFaves() {

	if(PJGlobalOption.startup != 1){
		exec("prefs/PJClientSchemes.cs");
		exec("prefs/PJClientPrefs.cs");
		exec("prefs/PJClientColors.cs");
		exec("prefs/PJClientFonts.cs");
		exec("prefs/PJScripts.cs");
		exec("scripts/autoexec/panamajack/PJGuiProfiles.pj");
		PJGlobalOption.startup = 1;
	}

	if($PJScript::SuperHuds){
		if($PJscheme::MainHudStyle $= "Normal") {
			$PJGuiColor = "gui/";
		}else{
			$PJGuiColor = "schemes/" @ $PJscheme::MainHudStyle @ "/";
		}
	} else $PJGuiColor = "gui/";

	PJMakeDefaults();

	PJEvalFile("prefs/PJMegaFaves.txt");

	if($PJEnable::MegaFaves == 1) {
		addMegaFaves();
	}
}

function DispatchLaunchModeFaves2(){

	if(strlen($PJVersion) == 0) {
		cancel($noPJPackage);
		$noPJPackage = schedule(5000, 0, noPJPackage, "PJ Mega Faves");
	}
}

function savePJFavorite() {

//	parent::saveFavorite();
     %favetype = "";

     if($PJPref::MegaFaveType == 2) {
          %favetype = $PJMapname;
     }
     if($PJPref::MegaFaveType == 3) {
          %favetype = StripAll($PJRuleSet);
     	if($PJRuleSet $= "base" || $PJRuleSet $= "variant" || $PJRuleSet $= "bwadmin") {
               %favetype = "base";
          }
     }
     if($PJPref::MegaFaveType == 4) {
          %favetype = $PJMissionType;
     }


//	if($PJScript::MegaFaves == 1 && $PJEnable::MegaFaves == 1) {
		if ( $pref::FavCurrentSelect !$= "" ) {
			%favName = $Hud['inventoryScreen'].staticData[1, 1].getValue();
			$pref::FavNames[$pref::FavCurrentSelect] = %favName;
			if($PJScript::MegaFaves == 1 && $PJEnable::MegaFaves == 1)
				$PJFaves::FavNames[%favetype @ $pref::FavCurrentSelect] = %favName;
			$Hud['inventoryScreen'].staticData[0, $pref::FavCurrentSelect - ($pref::FavCurrentList * 10) + 1].setText( strupr( %favName ) );
			//$Hud[%tag].staticData[1, 1].setValue( %favName );
			%favList = $Hud['inventoryScreen'].data[0, 1].type TAB $Hud['inventoryScreen'].data[0, 1].getValue();
			for ( %i = 1; %i < $Hud['inventoryScreen'].count; %i++ ) {
				%name = $Hud['inventoryScreen'].data[%i, 1].getValue();
				if ( %name $= invalid )
					%name = "EMPTY";
				%favList = %favList TAB $Hud['inventoryScreen'].data[%i, 1].type TAB %name;
			}
			$pref::Favorite[$pref::FavCurrentSelect] = %favList;
			if($PJScript::MegaFaves == 1 && $PJEnable::MegaFaves == 1)
				$PJFaves::Favorite[%favetype @ $pref::FavCurrentSelect] = %favList;
			echo("exporting pref::* to ClientPrefs.cs");
			export("$pref::*", "prefs/ClientPrefs.cs", False);
               export("$PJFaves::*", "prefs/PJMegaFaves.txt", False);
		}
//	}
}

function handlePJLoadInfo (%msgType, %msgString, %bitmapName, %mapName, %missionType) {

	if($BasePlusLoad2 == 0){
	$PJMapname = StripAll(detag(%mapName));
	$PJMissionType = StripAll(detag(%missionType));

//echo("Mission Type: "@$PJMissionType);

	if($PJScript::MegaFaves == 1 && $PJEnable::MegaFaves == 1) {
		%favetype = "";

		if($PJPref::MegaFaveType == 2) {
			%favetype = $PJMapname;
		}
		if($PJPref::MegaFaveType == 3) {
			%favetype = StripAll($PJRuleSet);
     	    if($PJRuleSet $= "base" || $PJRuleSet $= "variant" || $PJRuleSet $= "bwadmin") {
                    %favetype = "base";
               }
		}
		if($PJPref::MegaFaveType == 4) {
			%favetype = $PJMissionType;
		}

		for(%i = 0; %i < $PJPref::FaveLimit; %i++) {
			$pref::FavNames[%i] = $PJFaves::FavNamesDefault[%i];
			if(StrLen($PJFaves::FavNames[%favetype @ %i]) > 1)
				$pref::FavNames[%i] = $PJFaves::FavNames[%favetype @ %i];

			$pref::Favorite[%i] = $PJFaves::FavoriteDefault[%i];
			if(StrLen($PJFaves::Favorite[%favetype @ %i]) > 1)
				$pref::Favorite[%i] = $PJFaves::Favorite[%favetype @ %i];
		}
	}
//echo("PJMap = "@$PJMapname@", PJMission = "@$PJMissionType);
		$BasePlusLoad2 = 1;
}
}

// Mega Faves Events
function addMegaFaves() {
	addMessageCallBack('MsgLoadInfo', handlePJLoadInfo);
}

// Mega Faves Events
function removeMegaFaves() {
	removeMessageCallBack('MsgLoadInfo', handlePJLoadInfo);
}

//
// Mega Faves Options
//

function PJMegaFavesOptionDlg::onWake(%this) {

	PJ_Faves.setText("Mega Faves Options v" @ $PJVersion::MegaFaves);
     %temp = MegaFave @ $PJPref::MegaFaveType;
     %temp.setValue( true );

}

function PJMegaFavesOptionDlg::onSleep(%this) {

	if($PJScript::MegaFaves == 1 && $PJEnable::MegaFaves == 1 && LobbyGui.isAwake() == 1) {
		%favetype = "";

		if($PJPref::MegaFaveType == 2) {
			%favetype = $PJMapname;
		}
		if($PJPref::MegaFaveType == 3) {
			%favetype = StripAll($PJRuleSet);
     	    if($PJRuleSet $= "Base" ||$PJRuleSet $= "base" || $PJRuleSet $= "variant" || $PJRuleSet $= "bwadmin") {
                    %favetype = "base";
               }
		}
		if($PJPref::MegaFaveType == 4) {
			%favetype = $PJMissionType;
		}

		for(%i = 0; %i < $PJPref::FaveLimit; %i++) {
			$pref::FavNames[%i] = $PJFaves::FavNamesDefault[%i];
			if(StrLen($PJFaves::FavNames[%favetype @ %i]) > 1)
				$pref::FavNames[%i] = $PJFaves::FavNames[%favetype @ %i];

			$pref::Favorite[%i] = $PJFaves::FavoriteDefault[%i];
			if(StrLen($PJFaves::Favorite[%favetype @ %i]) > 1)
				$pref::Favorite[%i] = $PJFaves::Favorite[%favetype @ %i];
		}

          %temp = $pref::FavCurrentSelect;

          if($pref::FavCurrentSelect == 0) {
               loadFavorite( 1, 0 );
          } else {
               loadFavorite( 0, 0 );
          }

          loadFavorite( %temp, 0 );
	}
}

function PJMakeDefaults() {

	%NamesDefault0 = "SCOUT ASSASSIN";
	%NamesDefault1 = "SCOUT SNIPER";
	%NamesDefault10 = "SCOUT FLAG CHASER";
	%NamesDefault11 = "ASSAULT DESTROYER";
	%NamesDefault12 = "LANDSPIKE DEPLOYER";
	%NamesDefault13 = "INVENTORY DEPLOYER";
	%NamesDefault14 = "FORWARD ASSAULT";
	%NamesDefault15 = "EARLY WARNING";
	%NamesDefault16 = "DECOY";
	%NamesDefault17 = "HEAVY LOVE";
	%NamesDefault18 = "FLAG DEFENDER";
	%NamesDefault19 = "INFILTRATOR";
	%NamesDefault2 = "SCOUT DEFENSE";
	%NamesDefault3 = "ASSAULT OFFENSE";
	%NamesDefault4 = "ASSAULT DEPLOYER";
	%NamesDefault5 = "ASSAULT DEFENSE";
	%NamesDefault6 = "TAILGUNNER";
	%NamesDefault7 = "JUGGERNAUT OFFENSE";
	%NamesDefault8 = "JUGGERNAUT DEPLOYER";
	%NamesDefault9 = "JUGGERNAUT DEFENSE";
	%Default0 = "armor\tScout\tweapon\tPlasma Rifle\tweapon\tChaingun\tweapon\tShocklance\tpack\tCloak Pack\tGrenade\tWhiteout Grenade\tMine\tMine";
	%Default1 = "armor\tScout\tweapon\tLaser Rifle\tweapon\tSpinfusor\tweapon\tGrenade Launcher\tpack\tEnergy Pack\tGrenade\tFlare Grenade\tMine\tMine";
	%Default10 = "armor\tScout\tweapon\tChaingun\tweapon\tGrenade Launcher\tweapon\tELF Projector\tpack\tEnergy Pack\tGrenade\tConcussion Grenade\tMine\tMine";
	%Default11 = "armor\tAssault\tweapon\tBlaster\tweapon\tPlasma Rifle\tweapon\tSpinfusor\tweapon\tGrenade Launcher\tpack\tShield Pack\tGrenade\tGrenade\tMine\tMine";
	%Default12 = "armor\tAssault\tweapon\tChaingun\tweapon\tSpinfusor\tweapon\tPlasma Rifle\tweapon\tGrenade Launcher\tpack\tLandspike Turret\tGrenade\tGrenade\tMine\tMine";
	%Default13 = "armor\tAssault\tweapon\tPlasma Rifle\tweapon\tSpinfusor\tweapon\tGrenade Launcher\tweapon\tChaingun\tpack\tInventory Station\tGrenade\tGrenade\tMine\tMine";
	%Default14 = "armor\tAssault\tweapon\tELF Projector\tweapon\tGrenade Launcher\tweapon\tSpinfusor\tweapon\tMissile Launcher\tpack\tEnergy Pack\tGrenade\tWhiteout Grenade\tMine\tMine";
	%Default15 = "armor\tAssault\tweapon\tChaingun\tweapon\tSpinfusor\tweapon\tGrenade Launcher\tweapon\tELF Projector\tpack\tPulse Sensor Pack\tGrenade\tConcussion Grenade\tMine\tMine";
	%Default16 = "armor\tScout\tweapon\tChaingun\tweapon\tGrenade Launcher\tweapon\tSpinfusor\tpack\tSensor Jammer Pack\tGrenade\tWhiteout Grenade\tMine\tMine";
	%Default17 = "armor\tJuggernaut\tweapon\tChaingun\tweapon\tSpinfusor\tweapon\tPlasma Rifle\tweapon\tFusion Mortar\tweapon\tMissile Launcher\tpack\tShield Pack\tGrenade\tConcussion Grenade\tMine\tMine";
	%Default18 = "armor\tJuggernaut\tweapon\tSpinfusor\tweapon\tGrenade Launcher\tweapon\tFusion Mortar\tweapon\tPlasma Rifle\tweapon\tChaingun\tpack\tShield Pack\tGrenade\tGrenade\tMine\tMine";
	%Default19 = "armor\tScout\tweapon\tChaingun\tweapon\tSpinfusor\tweapon\tShocklance\tpack\tSatchel Charge\tGrenade\tDeployable Camera\tMine\tMine";
	%Default2 = "armor\tScout\tweapon\tBlaster\tweapon\tSpinfusor\tweapon\tPlasma Rifle\tpack\tShield Pack\tGrenade\tGrenade\tMine\tMine";
	%Default3 = "armor\tAssault\tweapon\tPlasma Rifle\tweapon\tSpinfusor\tweapon\tGrenade Launcher\tweapon\tChaingun\tpack\tShield Pack\tGrenade\tGrenade\tMine\tMine";
	%Default4 = "armor\tAssault\tweapon\tPlasma Rifle\tweapon\tBlaster\tweapon\tSpinfusor\tweapon\tMissile Launcher\tpack\tInventory Station\tGrenade\tDeployable Camera\tMine\tMine";
	%Default5 = "armor\tAssault\tweapon\tChaingun\tweapon\tSpinfusor\tweapon\tMissile Launcher\tweapon\tELF Projector\tpack\tShield Pack\tGrenade\tConcussion Grenade\tMine\tMine";
	%Default6 = "armor\tAssault\tweapon\tChaingun\tweapon\tGrenade Launcher\tweapon\tBlaster\tweapon\tMissile Launcher\tpack\tAmmunition Pack\tGrenade\tFlare Grenade\tMine\tMine";
	%Default7 = "armor\tJuggernaut\tweapon\tPlasma Rifle\tweapon\tSpinfusor\tweapon\tGrenade Launcher\tweapon\tFusion Mortar\tweapon\tMissile Launcher\tpack\tAmmunition Pack\tGrenade\tGrenade\tMine\tMine";
	%Default8 = "armor\tJuggernaut\tweapon\tChaingun\tweapon\tMissile Launcher\tweapon\tFusion Mortar\tweapon\tPlasma Rifle\tweapon\tBlaster\tpack\tInventory Station\tGrenade\tDeployable Camera\tMine\tMine";
	%Default9 = "armor\tJuggernaut\tweapon\tBlaster\tweapon\tPlasma Rifle\tweapon\tGrenade Launcher\tweapon\tMissile Launcher\tweapon\tFusion Mortar\tpack\tShield Pack\tGrenade\tConcussion Grenade\tMine\tMine";

	for(%i = 0; %i < 20; %i++) {

		$PJFaves::FavNamesDefault[%i] = $pref::FavNames[%i];
		$PJFaves::FavoriteDefault[%i] = $pref::Favorite[%i];

		if($PJFaves::FavNamesDefault[%i] $= "")
			$PJFaves::FavNamesDefault[%i] = %NamesDefault[%i];

		if($PJFaves::FavoriteDefault[%i] $= "")
			$PJFaves::FavoriteDefault[%i] = %Default[%i];

		if($pref::FavNames[%i] $= "")
			$pref::FavNames[%i] = %NamesDefault[%i];

		if($pref::Favorite[%i] $= "")
			$pref::Favorite[%i] = %Default[%i];
	}
}

$PJPref::FaveLimit = 20;

// 1 = 20+ Faves Only
// 2 = 20+ Faves Per Map
// 3 = 20+ Faves Per Mod
// 4 = 20+ Faves Per Gametype
$PJPref::MegaFaveType = 1; 

$PJScript::MegaFaves = 1;
$PJEnable::MegaFaves = 1;


